# py2many: Python to many CLike languages transpiler

![Build](https://github.com/adsharma/py2many/actions/workflows/main.yml/badge.svg)
![License](https://img.shields.io/github/license/adsharma/py2many?color=brightgreen)

## Why

Python is popular, easy to program in, but has poor runtime
performance. We can fix that by transpiling a subset of the language
into a more performant, statically typed language.

A second benefit is security. Writing security sensitive
code in a low level language like C is error prone and could
lead to privilege escalation. Specialized languages such as
[wuffs](https://github.com/google/wuffs) exist to address this use
case. py2many can be a more general purpose solution to the problem
where you can verify the source via unit tests before you transpile.

A third potential use case is to accelerate python code by transpiling
it into an [extension](https://github.com/adsharma/py2many/issues/62)

Swift and Kotlin dominate the mobile app development workflow. However, there is
no one solution that works well for lower level libraries where there is desire
to share code between platforms. Kotlin Mobile Multiplatform (KMM) is a player
in this place, but it hasn't really caught on. py2many provides an alternative.

Lastly, it's a great educational tool to learn a new language by implementing
a backend for your favorite language.

## Status

Rust is the language where the focus of development has been. C++14 is historically
the first language to be supported.

Preliminary support exists for Julia, Kotlin, Nim, Go and Dart.

## History

Based on Julian Konchunas' pyrs
http://github.com/konchunas/pyrs

Based on Lukas Martinelli Py14
(https://github.com/lukasmartinelli/py14) and Py14/python-3
(https://github.com/ProgVal/py14/tree/python-3) branch by Valentin
Lorentz.

## Example

Original Python version.

```python
def fib(i: int) -> int:
    if i == 0 or i == 1:
        return 1
    return fib(i - 1) + fib(i - 2)
```

Transpiled Rust code:

```rust
fn fib(i: i32) -> i32 {
    if i == 0 || i == 1 {
        return 1;
    }
    return (fib((i - 1)) + fib((i - 2)));
}
```

Transpiled code for other languages:

https://github.com/adsharma/py2many/tree/main/tests/expected (fib*)


## Trying it out

Requirements:
- python 3
- clang
- rustc

Local installation:

```
./setup.py install --user  # installs to $HOME/.local
```

OR

```
sudo ./setup.py install  # installs systemwide
```

Add the py2many script to your $PATH and run:

Transpiling:

```
py2many --cpp=1 /tmp/fib.py
py2many --rust=1 /tmp/fib.py
py2many --julia=1 /tmp/fib.py
py2many --kotlin=1 /tmp/fib.py
py2many --nim=1 /tmp/fib.py
py2many --dart=1 /tmp/fib.py
py2many --go=1 /tmp/fib.py
```

Compiling:

```
clang fib.cpp
rustc fib.rs
...
```

struct Rectangle
    height::ST0
    length::ST1
end

function __init__{T0,T1}(self::Rectangle, height::T0, length::T1)
    self.height = height
    self.length = length
end

function main()
    r = Rectangle()
end

using SuperEnum

@se Colors begin
    RED = 0
    GREEN = 1
    BLUE = 2

end

@se Permissions begin
    R = 1
    W = 2
    X = 16

end

function show()
    color_map = Dict(Colors.RED => "red", Colors.GREEN => "green", Colors.BLUE => "blue")
    a = Colors.GREEN
    if a == Colors.GREEN
        println(join(["green"], " "))
    else

        println(join(["Not green"], " "))
    end
    b = Permissions.R
    if b == Permissions.R
        println(join(["R"], " "))
    else

        println(join(["Not R"], " "))
    end
    @assert(length(color_map) != 0)
end

function main()
    show()
end

main()

using SuperEnum

@se Colors begin
    RED => "red"
    GREEN => "green"
    BLUE => "blue"

end

function show()
    color_map = Dict(Colors.RED => "1", Colors.GREEN => "2", Colors.BLUE => "3")
    a = Colors.GREEN
    if a == Colors.GREEN
        println(join(["green"], " "))
    else

        println(join(["Not green"], " "))
    end
    println(join([length(color_map)], " "))
end

function main()
    show()
end

main()

function show()
let try_dummy = { //unsupported
raise!(Exception("foo")) # unsupported
}
let except!(Exception) = { //unsupported
println(join(["caught"], " "));
}
let try_dummy = { //unsupported
(3/0);
}
let except!(ZeroDivisionError) = { //unsupported
println(join(["OK"], " "));
}
let try_dummy = { //unsupported
raise!(Exception("foo")) # unsupported
}
let except!() = { //unsupported
println(join(["Got it"], " "));
}
end

function main()
show();
end

main()

code_0 = 0
code_1 = 1
l_a = [code_0, code_1]
code_a = "a"
code_b = "b"
l_b = [code_a, code_b]
function main()
    for i in l_a
        println(join([i], " "))
    end
    for i in l_b
        println(join([i], " "))
    end
    if "a" in ["a", "b"]
        println(join(["OK"], " "))
    end
end

main()

function nested_containers()::Bool
    CODES = Dict("KEY" => [1, 3])
    return 1 in CODES["KEY"]
end

function main()
    if nested_containers()
        println(join(["OK"], " "))
    end
end

main()

function bisect_right(data::Array{Int64}, item::Int64)::Int64
    low = 0
    high::Int64 = Int64(length(data))
    while low < high
        middle = Int64(floor(((low + high) / 2)))
        if item < data[middle+1]
            high = middle
        else

            low = (middle + 1)
        end
    end
    return low
end

function bin_it(limits::Array{Int64}, data::Array{Int64})::Array{Int64}
    bins = [0]
    for _x in limits
        push!(bins, 0)
    end
    for d in data
        bins[bisect_right(limits, d)+1] += 1
    end
    return bins
end

function main()
    limits = [23, 37, 43, 53, 67, 83]
    data = [
        95,
        21,
        94,
        12,
        99,
        4,
        70,
        75,
        83,
        93,
        52,
        80,
        57,
        5,
        53,
        86,
        65,
        17,
        92,
        83,
        71,
        61,
        54,
        58,
        47,
        16,
        8,
        9,
        32,
        84,
        7,
        87,
        46,
        19,
        30,
        37,
        96,
        6,
        98,
        40,
        79,
        97,
        45,
        64,
        60,
        29,
        49,
        36,
        43,
        55,
    ]
    @assert(bin_it(limits, data) == [11, 4, 2, 6, 9, 5, 13])
    println(join(["OK"], " "))
end

main()

struct Rectangle
    height::Int64
    length::Int64
end

function is_square(self::Rectangle)::Bool
    return self.height == self.length
end

function show()
    r = Rectangle(1, 1)
    @assert(is_square(r))
    r = Rectangle(1, 2)
    @assert(!(is_square(r)))
    println(join([r.height], " "))
    println(join([r.length], " "))
end

function main()
    show()
end

main()

function show()
    println(join(["b"], " "))
    println(join([2, "b"], " "))
    a::Float64 = 2.1
    println(join([a], " "))
    b = 2.1
    println(join([b], " "))
    c = true
    println(join([c ? ("True") : ("False")], " "))
end

function main()
    show()
end

main()

function compare_assert(a::Int64, b::Int64)
    @assert(a == b)
    @assert(!(0 == 1))
end

function main()
    @assert(true)
    @assert(!(false))
    compare_assert(1, 1)
    @assert(true)
    @assert(true)
    println(join(["OK"], " "))
end

main()

function comb_sort(seq::Array{Int64})::Array{Int64}
    gap = length(seq)
    swap = true
    while gap > 1 || swap
        gap = max(1, Int64(floor((gap / 1.25))))
        swap = false
        for i in (0:(length(seq)-gap)-1)
            if seq[i+1] > seq[(i+gap)+1]
                seq[i+1], seq[(i+gap)+1] = (seq[(i+gap)+1], seq[i+1])
                swap = true
            end
        end
    end
    return seq
end

function main()
    unsorted = [14, 11, 19, 5, 16, 10, 19, 12, 5, 12]
    expected = [5, 5, 10, 11, 12, 12, 14, 16, 19, 19]
    @assert(comb_sort(unsorted) == expected)
    println(join(["OK"], " "))
end

main()

using SuperEnum

@se Permissions begin
    R = 1
    W = 2
    X = 16

end

a = (Permissions.R | Permissions.W)
function main()
    if (a & Permissions.R)
        println(join(["R"], " "))
    end
end

function do_pass()
    # pass
end

function inline_pass()
    # pass
end

function inline_ellipsis()
    # ...
end

function indexing()::Int64
    sum = 0
    a::Array{Int64} = []
    for i in (0:10-1)
        push!(a, i)
        sum += a[i+1]
    end
    return sum
end

function infer_bool(code::Int64)::Bool
    return code in [1, 2, 4]
end

function show()
    a1 = 10
    b1 = 15
    b2 = 15
    @assert(b1 == 15)
    @assert(b2 == 15)
    b9 = 2
    b10 = 2
    @assert(b9 == b10)
    a2::Float64 = 2.1
    println(join([a2], " "))
    for i in (0:10-1)
        println(join([i], " "))
    end
    for i in (0:2:10-1)
        println(join([i], " "))
    end
    a3 = -(a1)
    a4 = (a3 + a1)
    println(join([a4], " "))
    t1 = a1 > 5 ? (10) : (5)
    @assert(t1 == 10)
    sum1 = indexing()
    println(join([sum1], " "))
    a5 = [1, 2, 3]
    println(join([length(a5)], " "))
    a9::Array{String} = ["a", "b", "c", "d"]
    println(join([length(a9)], " "))
    a6 = Set([1, 2, 3, 4])
    println(join([length(a6)], " "))
    a7 = Dict("a" => 1, "b" => 2)
    println(join([length(a7)], " "))
    a8 = true
    if a8
        println(join(["true"], " "))
    else

        if a4 > 0
            println(join(["never get here"], " "))
        end
    end
    if a1 == 11
        println(join(["false"], " "))
    else

        println(join(["true"], " "))
    end
    if 1 != nothing
        println(join(["World is sane"], " "))
    end
    do_pass()
    inline_pass()
    s = "1    2"
    println(join([s], " "))
end

function main()
    show()
end

main()

function foo()
    a = 10
    b = 20
    _c1 = (a + b)
    _c2 = (a - b)
    _c3 = (a * b)
    _c4 = (a / b)
    _c5 = -(a)
    d = 2.0
    _e1 = (a + d)
    _e2 = (a - d)
    _e3 = (a * d)
    _e4 = (a / d)
    _f = -3.0
    _g = -(a)
end

function add1(x::Int8, y::Int8)::Int16
    return (x + y)
end

function add2(x::Int16, y::Int16)::Int32
    return (x + y)
end

function add3(x::Int32, y::Int32)::Int64
    return (x + y)
end

function add4(x::Int64, y::Int64)::Int64
    return (x + y)
end

function add5(x::UInt8, y::UInt8)::UInt16
    return (x + y)
end

function add6(x::UInt16, y::UInt16)::UInt32
    return (x + y)
end

function add7(x::UInt32, y::UInt32)::UInt64
    return (x + y)
end

function add8(x::UInt64, y::UInt64)::UInt64
    return (x + y)
end

function add9(x::Int8, y::UInt16)::UInt32
    return (x + y)
end

function sub(x::Int8, y::Int8)::Int8
    return (x - y)
end

function mul(x::Int8, y::Int8)::Int16
    return (x * y)
end

function fadd1(x::Int8, y::Float64)::Float64
    return (x + y)
end

function show()
    rv = fadd1(convert(Int8, 6), 6.0)
    @assert(rv == 12)
    println(join(["OK"], " "))
end

function main()
    foo()
    show()
end

main()

function bubble_sort(seq::Array{Int64})::Array{Int64}
    L = length(seq)
    for _ in (0:L-1)
        for n in (1:L-1)
            if seq[n+1] < seq[(n-1)+1]
                seq[(n-1)+1], seq[n+1] = (seq[n+1], seq[(n-1)+1])
            end
        end
    end
    return seq
end

function main()
    unsorted = [14, 11, 19, 5, 16, 10, 19, 12, 5, 12]
    expected = [5, 5, 10, 11, 12, 12, 14, 16, 19, 19]
    @assert(bubble_sort(unsorted) == expected)
    println(join(["OK"], " "))
end

main()

#[async]
function nested()::Int64
    return 42
end

#[async]
function async_main()
    @assert(await!(nested()) == 42)
    println(join(["OK"], " "))
end

function main()
    run(asyncio, async_main())
end

main()
